package de.fhhannover.inform.trust.ifmapj.exception;

/**
 * General Exception thrown by the IfmapJ library.
 * 
 * @author aw
 *
 */
public class IfmapException extends Exception {

	/**
	 * auto-generated
	 */
	private static final long serialVersionUID = 8922597065336001241L;
	
	/**
	 * describes what kind of exception it is.
	 */
	private final String mDescription;
	
	public IfmapException(String desc, String msg) {
		super(msg);
		
		if (desc == null)
			throw new NullPointerException();
		
		mDescription = desc;
	}

	public IfmapException(String desc, Exception e) {
		super(e);
		
		if (desc == null)
			throw new NullPointerException();
		
		mDescription = desc;
	}
	
	public String getDescription() {
		return mDescription;
	}
}
