package de.fhhannover.inform.trust.ifmapj.identifier;

/**
 * Represents an IF-MAP identifier with an administrative domain attribute.
 * 
 * @author aw
 *
 */
public abstract class IdentifierWithAd implements Identifier {
	
	private /* final */ String mAdministrativeDomain;

	protected IdentifierWithAd(String admDom) {
		mAdministrativeDomain = admDom;
	}

	/**
	 * Set to null or "" if no administrative-domain attribute is to be
	 * included.
	 * 
	 * @param administrativeDomain
	 * @deprecated
	 */
	public void setAdministrativeDomain(String administrativeDomain) {
		mAdministrativeDomain = administrativeDomain;
	}

	public String getAdministrativeDomain() {
		return mAdministrativeDomain;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		/* make life easier for the subclasses */
		if (getAdministrativeDomain() == null 
				|| getAdministrativeDomain().length() == 0)
			return "";
		else
			return ", " + getAdministrativeDomain();
	}
}
