package de.fhhannover.inform.trust.ifmapj.identifier;

/**
 * Represents an IF-MAP identity identifier.
 * 
 * @author aw
 *
 */
public class Identity extends IdentifierWithAd {
	
	private /* final */ String mName;
	
	private /* final */ IdentityType mType;

	private /* final */ String mOtherTypeDefinition;
	
	/**
	 * Package constructor.
	 */
	Identity(IdentityType type, String name, String admDom,
			String otherTypeDef) {
		super(admDom);
		
		mName = name;
		mType = type;
		mOtherTypeDefinition = otherTypeDef;
	}

	public String getName() {
		return mName;
	}

	@Deprecated
	public void setName(String name) {
		mName = name;
	}

	public IdentityType getType() {
		return mType;
	}

	@Deprecated
	public void setType(IdentityType type) {
		mType = type;
	}

	public String getOtherTypeDefinition() {
		return mOtherTypeDefinition;
	}

	@Deprecated
	public void setOtherTypeDefinition(String otherTypeDefinition) {
		mOtherTypeDefinition = otherTypeDefinition;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		String otherTypeDef = "";
		
		if (getType() == IdentityType.other) {
			otherTypeDef = ", " + getOtherTypeDefinition();
		}
		
		return String.format("id{%s, %s%s%s}", getName(), getType(),
				otherTypeDef, super.toString());
	}
}
