package de.fhhannover.inform.trust.ifmapj.identifier;

/**
 * Represents an IF-MAP ip-address identifier.
 * 
 * @author aw
 *
 */
public class IpAddress extends IdentifierWithAd {

	private /* final */ String mValue;
	
	private /* final */ IpAddressType mType;
	
	/**
	 * Package constructor.
	 */
	public IpAddress(IpAddressType type, String value, String admDom) {
		super(admDom);
		if (type == null)
			mType = IpAddressType.IPv4;
		else
			mType = type;
		
		mValue = value;
	}

	@Deprecated
	public void setType(IpAddressType type) {
		mType = type;
	}

	public IpAddressType getType() {
		return mType;
	}

	@Deprecated
	public void setValue(String value) {
		mValue = value;
	}

	public String getValue() {
		return mValue;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return String.format("ip{%s, %s%s}", getValue(), getType(),
				super.toString());
	}
}
