package de.fhhannover.inform.trust.ifmapj.log;

/**
 * Remove this as soon as possible, it's just here to provide a bit more
 * logging than System.out.println and I didn't want to include log4j...
 * 
 * @author aw
 *
 */
public class IfmapJLog {
	
	IfmapJLog() { }
	
	private static IfmapJLogger mLoggerInstance = new IfmapJLogger() {
			
			@Override
			public void trace(String msg) {
				System.out.println("TRACE: " + msg);
				System.out.flush();
				
			}

			@Override
			public void debug(String msg) {
				System.out.println("DEBUG: " + msg);
				System.out.flush();
			}
			
			@Override
			public void info(String msg) {
				System.out.println("INFO: " + msg);
				System.out.flush();
			}

			@Override
			public void warn(String msg) {
				System.out.println("WARN: " + msg);
				System.out.flush();
			}
			
			@Override
			public void error(String msg) {
				System.err.println("ERROR: " + msg);
				System.err.flush();
			}

		};
	
	public static void setLogger(IfmapJLogger logger) {
		mLoggerInstance = logger;
	}

	public static void trace(String msg) {
		if (mLoggerInstance != null)
			mLoggerInstance.trace(msg);
	}
	
	public static void debug(String msg) {
		if (mLoggerInstance != null)
			mLoggerInstance.debug(msg);
	}
	
	public static void info(String msg) {
		if (mLoggerInstance != null)
			mLoggerInstance.info(msg);
	}

	public static void warn(String msg) {
		if (mLoggerInstance != null)
			mLoggerInstance.warn(msg);
	}
	
	public static void error(String msg) {
		if (mLoggerInstance != null)
			mLoggerInstance.error(msg);
	}
}
