package de.fhhannover.inform.trust.ifmapj.messages;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Generic abstraction to hold elments fo {@link PublishRequest} and
 * {@link SubscribeRequest} implementations.
 * 
 * @author aw
 *
 * @param <T> the interface of the elements this request can contain
 */
class GenericObjectHolder<T> {
	
	private final List<T> mElements;
	
	GenericObjectHolder() {
		mElements = new ArrayList<T>();
	}
	
	protected void addElement(T el) {
		if (el == null)
			throw new NullPointerException("element not allowed to be null");
		
		mElements.add(el);
	}
	
	protected List<T> getElements() {
		return Collections.unmodifiableList(mElements);
	}
}
