package de.fhhannover.inform.trust.ifmapj.messages;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.w3c.dom.Document;

import de.fhhannover.inform.trust.ifmapj.identifier.Identifier;

/**
 * Implementation of interface {@link RequestFactory}
 * 
 * @author aw
 * @deprecated
 * Will be gone soon
 */
class RequestFactoryImpl implements RequestFactoryInternal, RequestFactory {

	@Override
	public PublishRequest createPublishReq() {
		return Requests.createPublishReq();
	}
	
	@Override
	public PublishRequest createPublishReq(PublishElement el) {
		return Requests.createPublishReq(el);
	}

	@Override
	public PublishRequest createPublishReq(Collection<PublishElement> list) {
		return Requests.createPublishReq(new ArrayList<PublishElement>(list));
	}

	@Override
	public NewSessionRequest createNewSessionReq() {
		return Requests.createNewSessionReq();
	}

	@Override
	public EndSessionRequest createEndSessionReq() {
		return Requests.createEndSessionReq();
	}

	@Override
	public RenewSessionRequest createRenewSessionReq() {
		return Requests.createRenewSessionReq();
	}

	@Override
	public PurgePublisherRequest createPurgePublisherReq() {
		return createPurgePublisherReq();
	}

	@Override
	public PollRequest createPollReq() {
		return Requests.createPollReq();
	}

	@Override
	public SubscribeRequest createSubscribeReq() {
		return Requests.createSubscribeReq();
	}
	
	@Override
	public SubscribeRequest createSubscribeReq(SubscribeElement el) {
		return Requests.createSubscribeReq(el);
	}

	@Override
	public SubscribeRequest createSubscribeReq(List<SubscribeElement> list) {
		return Requests.createSubscribeReq(list);
	}

	@Override
	public SearchRequest createSearchRequest() {
		return Requests.createSearchReq();
	}

	@Override
	public SearchRequest createSearchRequest(String matchLinks, Integer maxDepth,
			String termIdents, Integer maxSize, String resultFilter, Identifier start) {
		
		return Requests.createSearchReq(matchLinks, maxDepth, termIdents,
				maxSize, resultFilter, start);
	}

	@Override
	public PublishUpdate createPublishUpdate() {
		return Requests.createPublishUpdate();
	}

	@Override
	public PublishUpdate createPublishUpdate(Identifier i1, Document md) {
		return Requests.createPublishUpdate(i1, md);
	}
	
	@Override
	public PublishUpdate createPublishUpdate(Identifier i1, Document md,
			MetadataLifetime lifetime) {
		return Requests.createPublishUpdate(i1, null, md, lifetime);
	}

	@Override
	public PublishUpdate createPublishUpdate(Identifier i1,
			Collection<Document> mdlist, MetadataLifetime lifetime) {
		return Requests.createPublishUpdate(i1, null, mdlist, lifetime);
	}

	@Override
	public PublishUpdate createPublishUpdate(Identifier i1, Identifier i2,
			Document md) {
		return Requests.createPublishUpdate(i1, i2, md, MetadataLifetime.session);
	}

	@Override
	public PublishUpdate createPublishUpdate(Identifier i1, Identifier i2,
			Document md, MetadataLifetime lifetime) {
		return Requests.createPublishUpdate(i1, i2, md);
	}

	@Override
	public PublishUpdate createPublishUpdate(Identifier i1,
			Collection<Document> mdlist) {
		return Requests.createPublishUpdate(i1, null, mdlist);
	}

	@Override
	public PublishUpdate createPublishUpdate(Identifier i1, Identifier i2,
			Collection<Document> mdlist) {
		return Requests.createPublishUpdate(i1, i2, mdlist, MetadataLifetime.session);
	}

	@Override
	public PublishUpdate createPublishUpdate(Identifier i1, Identifier i2,
			Collection<Document> mdlist, MetadataLifetime lifetime) {
		return Requests.createPublishUpdate(i1, i2, mdlist, lifetime);
	}
	
	@Override
	public PublishNotify createPublishNotify() {
		return Requests.createPublishNotify();
	}

	@Override
	public PublishNotify createPublishNotify(Identifier i1, Document md) {
		return Requests.createPublishNotify(i1, null, md);
	}


	@Override
	public PublishNotify createPublishNotify(Identifier i1,
			Collection<Document> md) {
		return Requests.createPublishNotify(i1, null, md);
	}

	@Override
	public PublishNotify createPublishNotify(Identifier i1, Identifier i2,
			Document md) {
		return Requests.createPublishNotify(i1, i2, md);
	}

	@Override
	public PublishNotify createPublishNotify(Identifier i1, Identifier i2,
			Collection<Document> mdlist) {
		return Requests.createPublishNotify(i1, i2, mdlist);
	}
	
	@Override
	public PublishDelete createPublishDelete() {
		return Requests.createPublishDelete();
	}

	@Override
	public PublishDelete createPublishDelete(Identifier i1) {
		return Requests.createPublishDelete(i1, (String)null);
	}

	@Override
	public PublishDelete createPublishDelete(Identifier i1, Identifier i2) {
		return Requests.createPublishDelete(i1, i2, null);
	}

	@Override
	public PublishDelete createPublishDelete(Identifier i1, String filter) {
		return Requests.createPublishDelete(i1, null, filter);
	}

	@Override
	public PublishDelete createPublishDelete(Identifier i1, Identifier i2,
			String filter) {
		return Requests.createPublishDelete(i1, i2, filter);
	}

	@Override
	public SubscribeUpdate createSubscribeUpdate() {
		return Requests.createSubscribeUpdate();
	}
	
	@Override
	public SubscribeUpdate createSubscribeUpdate(String name,
			String matchLinks, Integer maxDepth, String termIdents,
			Integer maxSize, String resultFilter, Identifier start) {
		return Requests.createSubscribeUpdate(name, matchLinks, maxDepth,
				termIdents, maxSize, resultFilter, start);
	}

	@Override
	public SubscribeDelete createSubscribeDelete() {
		return Requests.createSubscribeDelete();
	}

	@Override
	public SubscribeDelete createSubscribeDelete(String name) {
		return Requests.createSubscribeDelete(name);
	}
}
