package de.fhhannover.inform.trust.ifmapj.messages;

import java.util.List;

public interface SearchResult extends Result {
	
	public enum Type {
		searchResult,
		updateResult,
		deleteResult,
		notifyResult
	}

	/**
	 * @return the contained {@link ResultItem} objects.
	 */
	public List<ResultItem> getResultItems();

	/**
	 * @return the name of the subscription, if the {@link SearchResult} is
	 * contained in a {@link PollResult}.
	 */
	public String getName();

	public SearchResult.Type getType();
}
