package de.fhhannover.inform.trust.ifmapj.messages;

import java.util.List;

/**
 * Interface to access data concerning a {@link SubscribeRequest}.
 * 
 * MAPCs can subscribe to changes occurring on a MAPS. The underlying mechanism
 * are subscriptions. A {@link SubscribeRequest} provides a MAPC the ability
 * to create and delte subscriptions using {@link SubscribeUpdate} and
 * {@link SubscribeDelete} elements, respectively.
 * 
 * @author aw
 *
 */
public interface SubscribeRequest extends Request {
	
	/**
	 * @param se the element to add to the list
	 * @throws NullPointerException if the element is null
	 */
	public void addSubscribeElement(SubscribeElement se);
	
	/**
	 * <b>Note:</b> The returned collection is unmodifiable.
	 * 
	 * @return the list of elements in the request
	 */
	public List<SubscribeElement> getSubscribeElements();
	
}
